#open "sys";;
#open "adl_syntax";;
#open "adl";;
#open "maple";;

let print_program = ref true;;

let open_adl_file s = try open_in (s^".adl") with
  Sys_error "No such file or directory" ->
	open_in (!luo_dir ^ "/Examples/"^s^".adl");;

let adl_parse s = 
   let input_stream = try open_adl_file s with
	Sys_error s -> failwith s
   in
   let read_fun = (fun() -> let c = input_char input_stream in 
	if !print_program then print_char c; c) in
   let cstrm = stream_from read_fun in
   let strm = stream_from (fun _ -> next_token cstrm) in
   try (let res = adl_file strm in close_in input_stream; res)
   with
    Parse_error ->
          print_newline();
          print_string "*** Syntax error."; print_newline();
          reset_lexer cstrm; stream_next strm; File([],[],[])
;;



