#open "prelude";;

let timings = ref false
and order = ref 1		(* order for equivalent *)
and evalf = ref false
and do_asymp = ref true
and do_solve = ref true
and chapter = ref false
and printlevel = ref 1 
and report_mode = ref false
and anafile = ref std_out
and id_not_def = ref ["true";"false"]
;;

let fnames = ref [(["toto";"tata"],"toto_of_tata")];;
(* list of pairs (list of functions, name of composition) that are already
	computed (or are being computed) *)

(***************** output functions for analyze *******************)

let output_line chan s = output_string chan (s ^ "\n");;

let mess n s = if !printlevel >= n then (print_string s; print_newline());;

let Repr x = ();;

let string_from_obj x = "";;

(* developper errors *)
let err fct stat x = if Repr x = ()
then failwith ("Error in function "^fct^" : "^stat)
else failwith ("Error in function "^fct^" : "^stat^" : "^string_from_obj (Repr x));;

let user_err stat x = failwith ("Error in Adl program: "^stat^": "^x);;

let error stat x = if Repr x = ()
then (print_string stat; failwith "")
else failwith (stat^" : "^string_from_obj (Repr x));;

let nwf s = 
print_string ("The data type specification is not well defined: "^s);
failwith "Error in Adl program"
;;

let pm fct x = if Repr x = ()
then failwith ("Partial match in "^fct)
else failwith ("Partial match in "^fct^" : "^string_from_obj (Repr x));;

let nyi fct s = failwith (fct ^ " : " ^ s ^ " not yet implemented");;

let war s = if not !report_mode then mess 1 ("Warning: "^s);;

let rap n s = if !printlevel >= n then
 (print_string s; print_newline();
	if !report_mode then (output_line !anafile s));;

let rep s = if !report_mode then (output_line !anafile s);;

let son = string_of_int;;

let snh n = (* should not happen *)
 print_string "Internal error number "; print_int n;
 print_string ": please contact Paul.Zimmermann@inria.fr\n";
 failwith ""
;;

