(* p. 121 *)
let K x y = x;;

(* p. 124 *)
exception Identity;;
let share f x = try f x with Identity -> x;;

(* p. 128 *)
let nth l n =
 if n<0 then failwith "nth" else (nth_op (l,n)
  where rec nth_op = function
     hd::_,0 -> hd
   | _::tl,n -> nth_op (tl,pred n)
   | [],_ -> failwith "nth")
;;

(* p. 129 *)
let find p = find_p
 where rec find_p = function
    x::l -> if p x then x else find_p l
  | _ -> failwith "find"
;;
let try_find f = try_find_f
 where rec try_find_f = function
  [] -> failwith "try_find" | h::t -> try f h with _ -> try_find_f t
;;

(* p. 133 *)
let end_it_list f default = function []->default | b::l -> it_list f b l;;

let last_char s = nth_char s (string_length s - 1);;

(* p. 136 *)
let partition p l = list_it fork l ([],[])
 where fork a (pos,neg) =
  if p a then a::pos,neg else pos,a::neg
;;
let flat ll = list_it (prefix @) ll [];;

(* p. 139 *)
let for_all2 rel = for_all2_rel
 where rec for_all2_rel = fun
   [] -> (function [] -> true | _ -> failwith "for_all2")
 | (x1::l1) -> function
	x2::l2 -> rel x1 x2 & for_all2_rel l1 l2
      | _ -> failwith "for_all2"
;;

(* p. 140 *)
let filter_pos p = share filter_aux
 where rec filter_aux = function
      [] -> raise Identity
  | x::l -> if p x then x::filter_aux l else share filter_aux l
;;
let filter_neg p = share filter_aux
 where rec filter_aux = function
      [] -> raise Identity
  | x::l -> if p x then share filter_aux l else x::filter_aux l
;;

(* p. 142 *)
let make_set l = share make_aux l
 where rec make_aux = function
    [] -> raise Identity
  | x::l -> if mem x l then share make_aux l else x::make_aux l
;;

(* p. 143 *)
let equal_snd u (x,y) = u=y;;
let rev_assoc x l = fst(find (equal_snd x) l);;

(* p. 148 *)
let interval n m = interval_n ([],m) 
 where rec interval_n (l,m) =
  if n>m then l else interval_n (m::l,pred m)
;;

let range = interval 1;;

(* p. 170 *)
let words s = let l = string_length s in words_aux 0
 where rec words_aux i = 
  if i=l then []
  else (if nth_char s i = ` ` then words_aux (i+1) else words_aux2 i 1)
 and words_aux2 i n =
  if i+n=l then [sub_string s i n]
  else (if nth_char s (i+n) = ` ` then (sub_string s i n)::(words_aux (i+n+1))
	else words_aux2 i (n+1))
;;

(* p. 171 *)
let string_of_bool = fun true -> "true" | false -> "false";;
let bool_of_string = fun "true" -> true | "false" -> false 
	| _ -> failwith "bool_of_string";;

let comline s = print_string ("comline "^s^"\n");;

let rec list p = function
  [< p x; (list p) l >] -> x::l
| [< >] -> []
;;

let cat s = let f = open_in s
in let rec cat2() = print_string (input_line f); print_newline(); cat2()
in try cat2() with End_of_file -> ()
;;

